package org.ucam.srcf.assassins.xml;

import net.sf.saxon.aelfred.SAXDriver;

import org.ucam.srcf.assassins.Debug;
import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.XMLParseException;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

/**
 * New WebPageParser algorithm that uses the SAX
 * @author Mike Cripps
 * 
 */
public class WebPageParserSAX extends WebPageParser {
	
	private XMLReader sax;
	private InputSource is;

	public WebPageParserSAX(String filename, Handler handler) throws AssassinSQLException, XMLParseException {
		if (Debug.debug) Debug.print(WebPageParser.class, "Constructor called");
		try {
			// Create a SAX source
			is = new InputSource(filename);
			// instantiate a SAX driver
			sax = new SAXDriver();
			// register Document handler
			sax.setContentHandler(handler);
			// register DTD handler
			sax.setDTDHandler(handler);
			// register Entity Resolver
			sax.setEntityResolver(handler);
			// register error handler
			sax.setErrorHandler(handler);
		} catch (Throwable t) {
			t.printStackTrace();
		}
		if (Debug.debug)
			Debug.print(WebPageParser.class, "Constructor finished");
	}

	/**
	 * @see org.ucam.srcf.assassins.xml.WebPageParser#generate()
	 */
	public void generate() throws AssassinSQLException {
		try {
			sax.parse(is);
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}
	
	public static void main(String [] args) throws Exception {
	    PageHandler eh = new PageHandler(System.out,"",new java.util.HashMap(),new java.util.HashMap(),new java.util.HashSet());
	    Config.init("/Applications/eclipse/workspace/autoumpire/xml/config.xml");
	    WebPageParser wp = new WebPageParserSAX("/Applications/eclipse/workspace/autoumpire/xml/wanted.xml",eh);
	    wp.generate();
	}

}
